package com.zcloud.controller.bus;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;
import org.apache.shiro.authz.annotation.RequiresPermissions;

import com.zcloud.controller.base.BaseController;
import com.zcloud.entity.Page;
import com.zcloud.util.DateUtil;
import com.zcloud.util.Jurisdiction;
import com.zcloud.util.ObjectExcelView;
import com.zcloud.util.Tools;
import com.zcloud.entity.PageData;
import com.zcloud.service.bus.NoticeCorpService;
import com.zcloud.service.bus.NoticeCorpUserIdService;
import com.zcloud.service.system.UsersService;

/**
 * 说明：企业通知公告
 * 作者：luoxiaobao
 * 时间：2021-01-22
 * 官网：www.zcloudchina.com
 */
@Controller
@RequestMapping("/noticecorp")
public class NoticeCorpController extends BaseController {

	@Autowired
	private NoticeCorpService noticecorpService;
	@Autowired
	private NoticeCorpUserIdService noticecorpuseridService;
	@Autowired
    private UsersService usersService;

	/**新增
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/add")
//	@RequiresPermissions("serviceNotice:add")
	@ResponseBody
	public Object add() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("NOTICECORP_ID", this.get32UUID());	//主键
		pd.put("ISDELETE", "0");	//是否删除
		pd.put("ISTOP", "0");	//是否置顶（0否 1是）
		pd.put("STATUS", "0");	//状态（0：未发布   1：发布）
		pd.put("USERNAME", Jurisdiction.getUsername());					//用户名
		pd.put("CREATOR", Jurisdiction.getName());						//发布人
		pd.put("CREATTIME", DateUtil.date2Str(new Date()));					//发布时间
		pd.put("CORP_INFO_ID", Jurisdiction.getCORPINFO_ID());
		pd.put("ISALL", pd.get("ISALL"));
		String xzUserIds = "";
		if("yes".equals( pd.get("ISALL"))) {
			//获取所有的用户
			//放入关系表中
			Page page =new Page();
			pd.put("CORPINFO_ID",Jurisdiction.getCORPINFO_ID());
			page.setPd(pd);
			List<PageData>	userList = usersService.userlistPage(page);		//列出用户列表
			for (PageData pageData : userList) {
				xzUserIds +=pageData.getString("USER_ID")+",";
			}
			xzUserIds = xzUserIds.substring(0,xzUserIds.length()-1);
		}else {
			xzUserIds = pd.getString("userIds");
		}
		if(xzUserIds != null){
			String[] userIds = xzUserIds.split(",");
			if(userIds.length>0) {
				List<Map<String, Object>> list = new ArrayList<>();
				Map<String , Object> map2 = new HashMap<>();
				for (int i = 0; i < userIds.length; i++) {
					map2 = new HashMap<>();
					map2.put("NOTICECORP_ID", pd.get("NOTICECORP_ID"));
					map2.put("USER_ID", userIds[i]);
					map2.put("NOTICECORPUSERID_ID", this.get32UUID());
					list.add(map2);
				}
				PageData pd2 = new PageData();
				pd2.put("list", list);
				noticecorpuseridService.saveAll(pd2);
			}
		}
		noticecorpService.save(pd);
		map.put("result", errInfo);
		return map;
	}

	/**删除
	 * @param out
	 * @throws Exception
	 */
	@RequestMapping(value="/delete")
//	@RequiresPermissions("serviceNotice:del")
	@ResponseBody
	public Object delete() throws Exception{
		Map<String,String> map = new HashMap<String,String>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		noticecorpService.delete(pd);
		PageData pd2 = new PageData();
		pd2.put("NOTICECORP_ID", pd.getString("NOTICECORP_ID"));//清除公告关系表
		noticecorpuseridService.deleteByNotId(pd2);
		map.put("result", errInfo);				//返回结果
		return map;
	}

	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit")
//	@RequiresPermissions("serviceNotice:edit")
	@ResponseBody
	public Object edit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		noticecorpService.edit(pd);
		map.put("result", errInfo);
		return map;
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/list")
//	@RequiresPermissions("serviceNotice:list")
	@ResponseBody
	public Object list(Page page) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String KEYWORDS = pd.getString("KEYWORDS");						//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))pd.put("KEYWORDS", KEYWORDS.trim());
		pd.put("CORP_INFO_ID", Jurisdiction.getCORPINFO_ID());
		page.setPd(pd);
		List<PageData>	varList = noticecorpService.list(page);	//列出NOTICECORP列表
		List<PageData> countNotList = new ArrayList<>();
		if(varList.size()>0) {
			String [] notids = new String [varList.size()];
			for(int i=0;i<varList.size();i++) {
				PageData pageData =varList.get(i);
				notids[i] = pageData.getString("NOTICECORP_ID");
			}
			PageData pd2 = new PageData();
			pd2.put("notIdsVal", notids);
			Page page2 = new Page();
			page2.setPd(pd2);
			countNotList = noticecorpuseridService.getTypeCountByNotId(page2);
		}

		map.put("varList", varList);
		map.put("countNotList",countNotList);
		map.put("page", page);
		map.put("result", errInfo);
		return map;
	}

	 /**去修改页面获取数据`
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/goEdit")
//	@RequiresPermissions("serviceNotice:edit")
	@ResponseBody
	public Object goEdit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = noticecorpService.findById(pd);	//根据ID读取
		//修改已读状态
		PageData pd2 = new PageData();//NOTICECORP_ID
		pd2.put("NOTICECORP_ID", pd.getString("NOTICECORP_ID"));
		pd2.put("USER_ID", Jurisdiction.getUSER_ID());
		pd2.put("TYPE", "1");
		noticecorpuseridService.edit(pd2);
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	 /**批量删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/deleteAll")
//	@RequiresPermissions("serviceNotice:del")
	@ResponseBody
	public Object deleteAll() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String DATA_IDS = pd.getString("DATA_IDS");
		if(Tools.notEmpty(DATA_IDS)){
			String ArrayDATA_IDS[] = DATA_IDS.split(",");
			noticecorpService.deleteAll(ArrayDATA_IDS);
			errInfo = "success";
		}else{
			errInfo = "error";
		}
		map.put("result", errInfo);				//返回结果
		return map;
	}

	 /**导出到excel
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/excel")
	@RequiresPermissions("toExcel")
	public ModelAndView exportExcel() throws Exception{
		ModelAndView mv = new ModelAndView();
		PageData pd = new PageData();
		pd = this.getPageData();
		Map<String,Object> dataMap = new HashMap<String,Object>();
		List<String> titles = new ArrayList<String>();
		titles.add("用户名");	//1
		titles.add("发布人");	//2
		titles.add("发布时间");	//3
		titles.add("公告简介");	//4
		titles.add("公告内容");	//5
		titles.add("是否全显");	//6
		titles.add("是否删除");	//7
		titles.add("是否置顶");	//8
		titles.add("是否发布，0否1是");	//9
		titles.add("企业ID");	//10
		dataMap.put("titles", titles);
		List<PageData> varOList = noticecorpService.listAll(pd);
		List<PageData> varList = new ArrayList<PageData>();
		for(int i=0;i<varOList.size();i++){
			PageData vpd = new PageData();
			vpd.put("var1", varOList.get(i).getString("USERNAME"));	    //1
			vpd.put("var2", varOList.get(i).getString("CREATOR"));	    //2
			vpd.put("var3", varOList.get(i).getString("CREATTIME"));	    //3
			vpd.put("var4", varOList.get(i).getString("SYNOPSIS"));	    //4
			vpd.put("var5", varOList.get(i).getString("CONTENT"));	    //5
			vpd.put("var6", varOList.get(i).getString("ISALL"));	    //6
			vpd.put("var7", varOList.get(i).get("ISDELETE").toString());	//7
			vpd.put("var8", varOList.get(i).getString("ISTOP"));	    //8
			vpd.put("var9", varOList.get(i).getString("STATUS"));	    //9
			vpd.put("var10", varOList.get(i).getString("CORP_INFO_ID"));	    //10
			varList.add(vpd);
		}
		dataMap.put("varList", varList);
		ObjectExcelView erv = new ObjectExcelView();
		mv = new ModelAndView(erv,dataMap);
		return mv;
	}
	/**变更置顶状态
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/changeIsTop")
//	@RequiresPermissions("noticecorp:edit")
	@ResponseBody
	public Object changeIsTop() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		PageData notice = noticecorpService.findById(pd);
		notice.put("ISTOP", pd.getString("ISTOP"));
		this.noticecorpService.edit(notice);
		map.put("result", errInfo);
		return map;
	}
	/**变更状态
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/changeStatus")
//	@RequiresPermissions("noticecorp:edit")
	@ResponseBody
	@Transactional //开启事物
	public Object changeStatus() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = noticecorpService.findById(pd);
		if(pd.get("STATUS").equals("1")) {
			pd.put("STATUS",0);
			pd.put("OPERATOR", Jurisdiction.getUsername());	//操作人
			pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//操作时间
			noticecorpService.edit(pd);
		}else {
			pd.put("STATUS",1);
			pd.put("OPERATOR", Jurisdiction.getUsername());	//操作人
			pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//操作时间
			noticecorpService.edit(pd);
		}
		map.put("result", errInfo);
		return map;
	}

}
